## rlvm 0.08

=== SConstruct ===

import os
from SCons.Conftest import *

# 0.98.3 had a bug where it wasn't generating config.h files correctly. :(
EnsureSConsVersion(0, 98, 5)

############################################################# [ World options ]

AddOption('--release', action='store_true',
          help='Builds an optimized release for the platform.')
AddOption('--coverage', action='store_true',
          help='Builds the unit tests for running through gcov, runs them, '
          'runs gcov, and then generates an html report with lcov.')
AddOption('--fullstatic', action='store_true',
          help='Builds a static binary, linking in all libraries.')

# Set libraries used by all configurations and all binaries in rlvm.
env = Environment(
  tools = ["default", "rlvm"],

  LIBS = [
    "boost_program_options-mt",
    "boost_serialization-mt",
    "boost_iostreams-mt",
    "boost_filesystem-mt",
    "boost_date_time-mt",
    "boost_signals-mt",
    "boost_thread-mt",
    "boost_system-mt",
    "z"
  ],

  LOCAL_LIBS = [],

  CPPPATH = [
    "#/build",
    "#/src",
    "#/vendor",
  ],

  CPPFLAGS = [
    "--ansi",
    "-funsigned-char"
  ],

  CPPDEFINES = [
    "HAVE_CONFIG_H",

    # This prevents conflicts between SDL and GLEW. I shouldn't have to do
    # this, but the SDL_opengl.h and glew.h differ in const correctness...
    "NO_SDL_GLEXT"
  ],

  # Where the final binaries should be put.
  OUTPUT_DIR = "#/build/",

  # Where to output libraries that we've built because they aren't installed on
  # the system
  LIBRARY_DIR = "#/build/libraries",

  # Where under build/ to build.
  BUILD_DIR = "#/build/debug/",

  # Debug or Release.
  BUILD_TYPE = "Debug",

  # Whether we build the tests that require rlc to compile them.
  BUILD_RLC_TESTS = False,

  # Whether we build the test binary that requires lua.
  BUILD_LUA_TESTS = False,
)

if GetOption("fullstatic"):
  env["FULL_STATIC_BUILD"] = True

# Auto select the number of processors
if os.path.exists('/proc'):
  cpus = len([l for l in open('/proc/cpuinfo') if l.startswith('processor\t')])
else:
  cpus = 1
env.SetOption('num_jobs', cpus + 1)

# Use timestamps change, followed by MD5 for speed
env.Decider('MD5-timestamp')

if ARGUMENTS.get('VERBOSE') != '1':
  env['CCCOMSTR'] = 'Compiling $TARGET ...'
  env['CXXCOMSTR'] = 'Compiling $TARGET ...'
  env['SHCCCOMSTR'] = 'Compiling $TARGET ...'
  env['SHCXXCOMSTR'] = 'Compiling $TARGET ...'
  env['LINKCOMSTR'] = 'Linking $TARGET ...'
  env['ARCOMSTR'] = 'Archiving $TARGET ...'
  env['RANLIBCOMSTR'] = 'Indexing $TARGET ...'
  env['SHLINKCOMSTR'] = 'Linking $TARGET ...'

#########################################################################
## Platform Specific Locations
#########################################################################
if env['PLATFORM'] == "darwin":
  # Fink based mac
  if os.path.exists("/sw/"):
    env['ENV']['PATH'] += ":/sw/bin"
    env.Append(
      CPPPATH = ["/sw/include/"],
      LIBPATH = ["/sw/lib/"]
    )
  # Darwinports based mac
  if os.path.exists("/opt/local"):
    env['ENV']['PATH'] += ":/opt/local/bin"
    env.Append(
      CPPPATH = ["/opt/local/include/"],
      LIBPATH = ["/opt/local/lib/"]
    )
  if os.path.exists("/usr/local/"):
    env['ENV']['PATH'] += ":/usr/local/bin/"
    env.Append(
      CPPPATH = ["/usr/local/include/"],
      LIBPATH = ["/usr/local/lib/"]
    )

#########################################################################
## CheckBoost
#########################################################################
def CheckBoost(context, version):
  # Boost versions are in format major.minor.subminor
  v_arr = version.split(".")
  version_n = 0
  if len(v_arr) > 0:
    version_n += int(v_arr[0])*100000
    if len(v_arr) > 1:
      version_n += int(v_arr[1])*100
    if len(v_arr) > 2:
      version_n += int(v_arr[2])

  context.Message('Checking for Boost version >= %s... ' % (version))
  ret = context.TryRun("""
    #include <boost/version.hpp>

    int main()
    {
        return BOOST_VERSION >= %d ? 0 : 1;
    }
    """ % version_n, '.cpp')[0]
  context.Result(ret)
  return ret

def CheckGuichan(context):
  # We specifically check for 0.8 because the authors have said they'll do
  # sweeping, API breaking changed between major releases. gcnGuichanVersion()
  # doesn't change during minor releases.
  context.Message('Checking for guichan 0.8 with OpenGL and SDL support...')
  lastLIBS = context.env['LIBS']
  context.env.Append(LIBS = ['guichan', 'guichan_opengl', 'guichan_sdl'])
  ret = context.TryRun("""
#include <guichan.hpp>
#include <cstring>

int main(int argc, char **argv) {
  return std::strcmp(gcnGuichanVersion(), "0.8") != 0;
}
""", ".cc")[0]
  if not ret:
    context.env.Replace(LIBS = lastLIBS)
  context.Result( ret )
  return ret

def VerifyLibrary(config, library, header):
  if not config.CheckLibWithHeader(library, header, "c"):
    if config.CheckLib(library):
      print "You have " + library + " installed, but the development headers aren't installed."
    else:
      print "You need " + library + " to compile this program!"
    Exit(1)

def CheckForSystemLibrary(config, library_dict, componentlist):
  """
  Configure check to see if a certain library is installed, falling back on an
  included version. Most of this check is ripped off from CheckLib, but with
  custom handling on build failure, where instead we add the source to the
  dependency graph instead.
  """

  res = None
  if not GetOption("fullstatic"):
      res = config.CheckLibWithHeader(library_dict['library'],
                                      library_dict['include'],
                                      'cpp',
                                      call = library_dict['function'])

  if not res:
    lib_name = library_dict['library']
    print "(Using included version of %s)" % lib_name
    componentlist.append(lib_name)
    config.Define("HAVE_LIB" + lib_name, 1,
                  "Define to 1 if you have the `%s' library." % lib_name)


#########################################################################
## Configuration
#########################################################################
subcomponents = [ ]
static_sdl_libs = [ ]

config = env.Configure(custom_tests = {'CheckBoost'   : CheckBoost,
                                       'CheckGuichan' : CheckGuichan},
                       config_h="build/config.h")
if not config.CheckBoost('1.40'):
  print "Boost version >= 1.40 needed to compile rlvm!"
  Exit(1)

VerifyLibrary(config, 'ogg', 'ogg/ogg.h')
VerifyLibrary(config, 'vorbis', 'vorbis/codec.h')
VerifyLibrary(config, 'vorbisfile', 'vorbis/vorbisfile.h')

# In short, we do this because the SCons configuration system doesn't give me
# enough control over the test program. Even if the libraries are installed,
# they won't compile because SCons outputs "int main()" instead of "int
# main(int argc, char** argv)", which SDL macros into its own special SDL_main
# entrypoint, and the CheckXXX tests don't allow me a way to inject "#undef
# main" before I declare the main() function.
if env['PLATFORM'] != 'darwin':
  VerifyLibrary(config, 'SDL', 'SDL/SDL.h')
else:
  print "Can't properly detect SDL under OSX. Assuming you have the libraries."

# Libraries we need, but will use a local copy if not installed.
local_sdl_libraries = [
  {
    "include"  : 'GL/glew.h',
    "library"  : 'GLEW',
    "function" : 'glewInit();'
  },
  {
    'include'  : 'SDL/SDL_ttf.h',
    'library'  : 'SDL_ttf',
    'function' : 'TTF_Init();'
  },
  {
    'include'  : 'SDL/SDL_mixer.h',
    'library'  : 'SDL_mixer',
    'function' : ''
  },
  {
    'include'  : 'SDL/SDL_image.h',
    'library'  : 'SDL_image',
    'function' : ''
  }
]
for library_dict in local_sdl_libraries:
  CheckForSystemLibrary(config, library_dict, subcomponents)

if not config.CheckGuichan():
  print "(Using included copy of guichan)"
  subcomponents.append("guichan")

# Really optional libraries that jagarl's file loaders take advantage of if on
# the system.
config.CheckLibWithHeader('png', 'png.h', "cpp")
config.CheckLibWithHeader('jpeg', 'jpeglib.h', "cpp")
config.CheckLibWithHeader('mad', 'mad.h', "cpp")

if config.TryAction('rlc --version')[0] == 1:
  env['BUILD_RLC_TESTS'] = True

env = config.Finish()

### HACK! Until I make my own version of CheckLibWithHeader, just assume that
### we have the right libraries. This needs to be done after config.Finish() is
### called or else we get a really confusing error.
if env['PLATFORM'] == 'darwin':
  env.Append(LIBS=["SDL"])

# Get the configuration from sdl and freetype
env.ParseConfig("sdl-config --cflags")
env.ParseConfig("freetype-config --cflags --libs")

#########################################################################
## Building subcomponent functions
#########################################################################
for component in subcomponents:
  env.BuildSubcomponent(component)

#########################################################################
## Building things
#########################################################################

duplicate_files = 0
# Hacky Temporary Differentiation between release and debug:
if GetOption('release'):
  env["BUILD_DIR"] = "#/build/release"
  env['BUILD_TYPE'] = "Release"

  # Now add release optimizations to the environment
  env.Append(
    CPPFLAGS = [
      "-Os",
      "-DNDEBUG",
      "-DBOOST_DISABLE_ASSERTS"
    ]
  )

  # I would love to enable gc-sections everywhere, but it isn't enabled on OSX?
  if env['PLATFORM'] != "darwin":
    env.Append(
      CPPFLAGS = [
        "-ffunction-sections",
        "-fdata-sections",
        ],

      LINKFLAGS = [
        "-Wl,--gc-sections"
        ],
      )
elif GetOption('coverage'):
  env["BUILD_DIR"] = "#/build/coverage"
  env['BUILD_TYPE'] = "Release"

  env.Append(
    CPPFLAGS = [
      "-O0",
      "-g",
      "-fprofile-arcs",
      "-ftest-coverage"
    ],

    LIBS = [ "gcov" ]
  )
else:
  # Add debugging flags to all binaries here
  env.Append(
    CPPFLAGS = [
      "-g",
      "-O0"
    ]
  )

env.SConscript("SConscript",
               build_dir="$BUILD_DIR/",
               duplicate=0,
               exports='env')

if env['BUILD_RLC_TESTS'] == True:
  # Build the platform independent SEEN.TXT files.
  env.SConscript("test/SConscript.rlc",
                 build_dir="build/test",
                 duplicate=0,
                 exports='env')

  # Build the rlvmTests binary that uses those SEEN.TXT files.
  env.SConscript("SConscript.test",
                 build_dir="$BUILD_DIR/",
                 duplicate=0,
                 exports='env')

env.SConscript("SConscript.luarlvm",
               build_dir="$BUILD_DIR/",
               duplicate=0,
               exports='env')

if GetOption("fullstatic") and env['PLATFORM'] == 'darwin':
  env.SConscript("SConscript.cocoa",
                 build_dir="$BUILD_DIR/",
                 duplicate=0,
                 exports='env')

if GetOption("coverage"):
  env.SConscript("SConscript.coverage",
                 build_dir="$BUILD_DIR/",
                 duplicate=0,
                 exports='env')

=== debian/changelog ===
rlvm (0.08-1) unstable; urgency=low

  * New upstream release
  * Remove 002_Disable_OpenGL_abort.patch: already in upstream
  * Bump Standards-Version to 3.8.4: nothing need to be changed
  * Remove some changes in 001_Use_system_library.patch: already in upstream

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sat, 06 Mar 2010 08:17:59 +0800

rlvm (0.07-1) unstable; urgency=low

  * Make package to non-native.
  * Use DebSrc3.0 to override debian sub-directory in source tarball.
  * Refine copyright file: Use machine readable format
  * Add 001_Use_system_library.patch: Don't use embedded library when there
    are same library already in Debian sid.
  * Add 002_Disable_OpenGL_abort.patch: Don't abort when OpenGL error. Print
    error messages instead.
  * Add 003_port_to_gtest1.4.0.patch: Port to gtest 1.4.0 which is in sid.
  * Initial release (Closes: #535024)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 17 Dec 2009 17:07:16 +0800

rlvm (0.7) unstable; urgency=low

  * AIR Standard Edition can be completed, along with a few other games.
  * Fix intermittent crashes after loading saved games.
  * Prevernt text boxes from being positioned offscreen.
  * Implement shadows on text.
  * Support KOE voice archives.
  * Support loose ogg vorbis file voice patches.
  * Chinese and Korean rlBabel support compiled in by default. (I can't
    find any patches so this is untested).
  * Large number of small graphical fixes, including faces in text boxes,
    visual appearance of #SELBTNs (such as in Fuuko's route), and various
    shading effects.

 -- Elliot Glaysher <glaysher@umich.edu>  Sun, 15 Nov 2009 14:04:59 -0800

rlvm (0.6.3) unstable; urgency=low

  * Add fullscreen mode.
  * Internal unit testing changes.

 -- Elliot Glaysher <glaysher@umich.edu>  Sat, 15 Aug 2009 12:14:58 -0700

rlvm (0.6.2) unstable; urgency=low

  * Fixes regression where G00 animations weren't being played (Seen in
    Planetarian.)
  * Fixes regression where Yumemi's face in the final scene in Planetarian
    was being drawn twice because of poor clip rect handling.
  * Support for English patches compiled with debugging symbols stripped.
  * Temporarily disables scrollback due to crash that will be invasive to
    fix.

 -- Elliot Glaysher <glaysher@umich.edu>  Sun, 21 Jun 2009 13:51:58 -0700

rlvm (0.6.1) jaunty; urgency=low

  * rlvm now has basic (beta) support for the Baka-Tsuki CLANNAD English patch
    applied to CLANNAD_FV.
  * Minor bug fixes to normal CLANNAD_FV.

 -- Elliot Glaysher <glaysher@umich.edu>  Fri, 22 May 2009 20:00:45 -0700

rlvm (0.6) unstable; urgency=low

  * CLANNAD_FV is now playable to the end.
  * Supports selection buttons.
  * Supports OVK voice archives.

 -- Elliot Glaysher <glaysher@umich.edu>  Sat, 18 Apr 2009 20:10:57 -0700

rlvm (0.5) unstable; urgency=low

  * Kanon is now playable with NDT's English teaser patch
  * Fix a large number of graphical glitches including the calendar in
    Kanon blinking in and out and the CGs at the end of routes in CLANNAD
    not always clearing as the end credits are displayed.
  * New Kanon save games will restore the graphical contents of the screen
    properly; old Kanon save files will show a black background.
  * Fix OpenGL 1.4 support; Version 0.4 only worked on OpenGL 2.0 or higher
    graphics cards.

 -- Elliot Glaysher <glaysher@umich.edu>  Sat, 17 Jan 2009 12:00:03 -0800

rlvm (0.4) unstable; urgency=low

  * CLANNAD is now playable from a clean file to After Story True End. No
    testing has been done on side routes, though they may be playable.
  * All routes in Kanon Standard Edition are playable and have been tested.
  * There's now a partial default interface, allowing basic operations and a
    default save/load interface in games that don't provide their own (such as
    Kanon).
  * NOTE: There is still no support for rlBabel; text in translation
    patches still won't display correctly.

 -- Elliot Glaysher <glaysher@umich.edu>  Tue, 09 Dec 2008 19:55:00 -0800

rlvm (0.3) unstable; urgency=low

  * CLANNAD is playable through the end of Nagisa's route.
  * Replace name variables in text, such as '*A' as 'Tomoya' in CLANNAD.
  * Kanon SE is now playable past "Last Regrets," but the lack of loading
    or saving makes actual playing impracticle.
  * Reduce the memory footprint by keeping the last 100 pages of text in the
    scrollback buffer. Previously, the scrollback buffer was unbounded.
  * Scrolling through previous pages of text no longer crashes Planetarian.
  * Fix performance on the CLANNAD main menu.
  * Fix multiple crashing bugs.

 -- Elliot Glaysher <glaysher@umich.edu>  Sat, 04 Oct 2008 12:16:29 -0700

rlvm (0.2) unstable; urgency=low

  * Adds background music and sound effect support.
  * Adds custom cursor support.

 -- Elliot Glaysher <glaysher@umich.edu>  Tue, 24 Jul 2008 20:56:03 -0700

rlvm (0.1) unstable; urgency=low

  * Initial Release.
  * Compatible with Planetarian.

 -- Elliot Glaysher <glaysher@umich.edu>  Wed, 16 Apr 2008 20:38:12 -0700

=== debian/control ===
Source: rlvm
Section: games
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libsdl1.2-dev, libfreetype6-dev,
               libsdl-image1.2-dev, libsdl-mixer1.2-dev, libgl1-mesa-dev,
               libboost-dev, libglew1.5-dev, scons, libboost-filesystem-dev,
               libboost-serialization-dev, libboost-date-time-dev,
               libboost-iostreams-dev, libboost-program-options-dev,
               libboost-python-dev, libboost-signals-dev, pkg-config,
               libboost-thread-dev, libguichan-dev, quilt, zlib1g-dev,
               libsdl-ttf2.0-dev, liblua5.1-0-dev, libglew1.5-dev,
               libjpeg62-dev, libmad0-dev, libluabind-dev,
               libgtest-dev
Standards-Version: 3.8.4
Homepage: http://www.elliotglaysher.org/rlvm/

Package: rlvm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RealLive virtual machine clone
 rlvm is a Free Software reimplementation of VisualArt's KK's RealLive
 interpreter. RealLive is a game engine used to write visual novels, used in
 the games Kanon, Air, CLANNAD, and Planetarian, among many others.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export RLVM_NO_TEST=1

%:
	dh $@

override_dh_auto_build:
	scons --release

override_dh_auto_clean:
	dh_auto_clean
	rm -Rf build/ .sconf_temp/

## rlvm 0.09

=== SConstruct ===
--- 
+++ 
@@ -337,36 +337,36 @@
   )
 
 env.SConscript("SConscript",
-               build_dir="$BUILD_DIR/",
+               variant_dir="$BUILD_DIR/",
                duplicate=0,
                exports='env')
 
 if env['BUILD_RLC_TESTS'] == True:
   # Build the platform independent SEEN.TXT files.
   env.SConscript("test/SConscript.rlc",
-                 build_dir="build/test",
+                 variant_dir="build/test",
                  duplicate=0,
                  exports='env')
 
   # Build the rlvmTests binary that uses those SEEN.TXT files.
   env.SConscript("SConscript.test",
-                 build_dir="$BUILD_DIR/",
+                 variant_dir="$BUILD_DIR/",
                  duplicate=0,
                  exports='env')
 
 env.SConscript("SConscript.luarlvm",
-               build_dir="$BUILD_DIR/",
+               variant_dir="$BUILD_DIR/",
                duplicate=0,
                exports='env')
 
 if GetOption("fullstatic") and env['PLATFORM'] == 'darwin':
   env.SConscript("SConscript.cocoa",
-                 build_dir="$BUILD_DIR/",
+                 variant_dir="$BUILD_DIR/",
                  duplicate=0,
                  exports='env')
 
 if GetOption("coverage"):
   env.SConscript("SConscript.coverage",
-                 build_dir="$BUILD_DIR/",
+                 variant_dir="$BUILD_DIR/",
                  duplicate=0,
                  exports='env')

=== debian/changelog ===
rlvm (0.09-1) unstable; urgency=low

  * New upstream release
    - Preliminary support for Little Busters! (No support for Ectasy yet.)
    - Fix saving the current graphics state in most games.
    - Hide unavailable options in select() calls.
  * Bump Standards-Version to 3.9.1: nothing need to be changed

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 10 Nov 2010 22:46:10 +0800

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                libsdl-ttf2.0-dev, liblua5.1-0-dev, libglew1.5-dev,
                libjpeg62-dev, libmad0-dev, libluabind-dev,
                libgtest-dev
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Homepage: http://www.elliotglaysher.org/rlvm/
 
 Package: rlvm

## rlvm 0.10

=== SConstruct ===
--- 
+++ 
@@ -64,9 +64,6 @@
 
   # Debug or Release.
   BUILD_TYPE = "Debug",
-
-  # Whether we build the tests that require rlc to compile them.
-  BUILD_RLC_TESTS = False,
 
   # Whether we build the test binary that requires lua.
   BUILD_LUA_TESTS = False,
@@ -261,9 +258,6 @@
 config.CheckLibWithHeader('jpeg', 'jpeglib.h', "cpp")
 config.CheckLibWithHeader('mad', 'mad.h', "cpp")
 
-if config.TryAction('rlc --version')[0] == 1:
-  env['BUILD_RLC_TESTS'] = True
-
 env = config.Finish()
 
 ### HACK! Until I make my own version of CheckLibWithHeader, just assume that
@@ -341,18 +335,18 @@
                duplicate=0,
                exports='env')
 
-if env['BUILD_RLC_TESTS'] == True:
-  # Build the platform independent SEEN.TXT files.
-  env.SConscript("test/SConscript.rlc",
-                 variant_dir="build/test",
-                 duplicate=0,
-                 exports='env')
-
-  # Build the rlvmTests binary that uses those SEEN.TXT files.
-  env.SConscript("SConscript.test",
-                 variant_dir="$BUILD_DIR/",
-                 duplicate=0,
-                 exports='env')
+# Copy the platform independent SEEN.TXT files to output (we no longer depend
+# on rldev because I can no longer reliably compile it).
+env.SConscript("test/SConscript.rlc",
+               variant_dir="build/test",
+               duplicate=0,
+               exports='env')
+
+# Build the rlvmTests binary that uses those SEEN.TXT files.
+env.SConscript("SConscript.test",
+               variant_dir="$BUILD_DIR/",
+               duplicate=0,
+               exports='env')
 
 env.SConscript("SConscript.luarlvm",
                variant_dir="$BUILD_DIR/",

=== debian/changelog ===
rlvm (0.10-1) unstable; urgency=low

  * New upstream release
    - Tomoyo After Memorial Edition support.
    - Planetarian voice support.
    - Fix multiple errors in the handling of glosses.
    - Multiple crashers/graphics fixes.
  * Remove 003_port_to_gtest1.4.0.patch: Use google-mock now.
  * Add 002_fix_missing_include.patch: Fix missing include of header files.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sun, 06 Feb 2011 16:29:39 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libboost-thread-dev, libguichan-dev, quilt, zlib1g-dev,
                libsdl-ttf2.0-dev, liblua5.1-0-dev, libglew1.5-dev,
                libjpeg62-dev, libmad0-dev, libluabind-dev,
-               libgtest-dev
+               libgtest-dev, google-mock
 Standards-Version: 3.9.1
 Homepage: http://www.elliotglaysher.org/rlvm/
 
@@ -21,4 +21,5 @@
 Description: RealLive virtual machine clone
  rlvm is a Free Software reimplementation of VisualArt's KK's RealLive
  interpreter. RealLive is a game engine used to write visual novels, used in
- the games Kanon, Air, CLANNAD, and Planetarian, among many others.
+ the games Kanon, Air, CLANNAD, Planetarian, Tomoyo After and Little Busters,
+ among many others.

## rlvm 0.12

=== SConstruct ===
--- 
+++ 
@@ -25,7 +25,6 @@
     "boost_iostreams-mt",
     "boost_filesystem-mt",
     "boost_date_time-mt",
-    "boost_signals-mt",
     "boost_thread-mt",
     "boost_system-mt",
     "z"
@@ -40,12 +39,18 @@
   ],
 
   CPPFLAGS = [
-    "--ansi",
     "-funsigned-char"
   ],
 
   CPPDEFINES = [
     "HAVE_CONFIG_H",
+
+    # boost made a large non-backwards compatible change to their filesystem
+    # library. Specify version 2 explicitly.
+    ["BOOST_FILESYSTEM_VERSION", 2],
+
+    # We use gettext for translations.
+    "ENABLE_NLS",
 
     # This prevents conflicts between SDL and GLEW. I shouldn't have to do
     # this, but the SDL_opengl.h and glew.h differ in const correctness...
@@ -207,6 +212,7 @@
   print "Boost version >= 1.40 needed to compile rlvm!"
   Exit(1)
 
+VerifyLibrary(config, 'pthread', 'pthread.h')
 VerifyLibrary(config, 'ogg', 'ogg/ogg.h')
 VerifyLibrary(config, 'vorbis', 'vorbis/codec.h')
 VerifyLibrary(config, 'vorbisfile', 'vorbis/vorbisfile.h')
@@ -240,11 +246,12 @@
     'function' : ''
   },
   {
-    'include'  : 'SDL/SDL_image.h',
-    'library'  : 'SDL_image',
-    'function' : ''
+      'include'  : 'SDL/SDL_image.h',
+      'library'  : 'SDL_image',
+      'function' : ''
   }
 ]
+
 for library_dict in local_sdl_libraries:
   CheckForSystemLibrary(config, library_dict, subcomponents)
 
@@ -264,7 +271,7 @@
 ### we have the right libraries. This needs to be done after config.Finish() is
 ### called or else we get a really confusing error.
 if env['PLATFORM'] == 'darwin':
-  env.Append(LIBS=["SDL"])
+  env.Append(LIBS=["SDL", "intl", "iconv"])
 
 # Get the configuration from sdl and freetype
 env.ParseConfig("sdl-config --cflags")
@@ -330,10 +337,24 @@
     ]
   )
 
+# Cross platform core of rlvm. Produces librlvm.a and libsystem_sdl.a
 env.SConscript("SConscript",
                variant_dir="$BUILD_DIR/",
                duplicate=0,
                exports='env')
+
+# Run the correct port script. If we're on darwin, we'll run the cocoa version,
+# everywhere else we assume GTK+.
+if env['PLATFORM'] == 'darwin':
+  env.SConscript("SConscript.cocoa",
+                 variant_dir="$BUILD_DIR/",
+                 duplicate=0,
+                 exports='env')
+else:
+  env.SConscript("SConscript.gtk",
+                 variant_dir="$BUILD_DIR/",
+                 duplicate=0,
+                 exports='env')
 
 # Copy the platform independent SEEN.TXT files to output (we no longer depend
 # on rldev because I can no longer reliably compile it).
@@ -353,14 +374,14 @@
                duplicate=0,
                exports='env')
 
-if GetOption("fullstatic") and env['PLATFORM'] == 'darwin':
-  env.SConscript("SConscript.cocoa",
-                 variant_dir="$BUILD_DIR/",
-                 duplicate=0,
-                 exports='env')
-
 if GetOption("coverage"):
   env.SConscript("SConscript.coverage",
                  variant_dir="$BUILD_DIR/",
                  duplicate=0,
                  exports='env')
+
+# In addition to all that, we also want to build the translation files.
+env.Command("build/locale/ja/LC_MESSAGES/rlvm.mo",
+            "po/ja.po",
+            ["mkdir -p build/locale/ja/LC_MESSAGES/",
+             "msgfmt -o build/locale/ja/LC_MESSAGES/rlvm.mo po/ja.po"])

=== debian/changelog ===
rlvm (0.12-4ubuntu1) saucy; urgency=low

  * Drop obsolete -mt suffixes from boost libraries.
  * Add missing include in TextPage.hpp

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Tue, 27 Aug 2013 15:19:29 +0100

rlvm (0.12-4build1) quantal; urgency=low

  * Rebuild for libglew1.8.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 09 Sep 2012 21:03:31 +0100

rlvm (0.12-4) unstable; urgency=low

  * Add proper Build-Depends (Closes: #672944)
    - Add libogg-dev, libvorbis-dev, libpng-dev
  * Update debian/copyright to latest v1.0 format
    - Remove comma in Files field
  * Bump Standards-Version to 3.9.3: nothing needs to be changed

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 16 May 2012 03:44:49 +0800

rlvm (0.12-3) unstable; urgency=low

  * Remove libjpeg62-dev from Build-Depends (Closes: #634286)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 21 Jul 2011 13:11:58 +0800

rlvm (0.12-2) unstable; urgency=low

  * Use libjpeg-dev in Build-Depends. (Closes: #634286)
  * Build gtest/gmock as system don't provide shared libraries now.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 20 Jul 2011 14:11:39 +0800

rlvm (0.12-1) unstable; urgency=low

  [ Ying-Chun Liu (PaulLiu) <paulliu@debian.org> ]
  * New upstream release
  
  [ Elliot Glaysher <glaysher@umich.edu> ]
  * New GTK+ interface with desktop integration and UI refinements
  * Partial Japanese localizations
  * Fix graphics corruption in in-game dialogs when a dialog is brought
    up, and then fullscreen mode activated
  * Smooth the output of text in rlBabel using games
  * Don't play voice samples while fast forwarding

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 19 May 2011 00:28:44 +0800

rlvm (0.11-2) unstable; urgency=low

  * debian/patches/002_port_to_boost_146.patch: Fix FTBFS (Closes: #624910)
  * Bump Standards-Version to 3.9.2: nothing need to be changed

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 03 May 2011 03:21:03 +0800

rlvm (0.11-1) unstable; urgency=low

  * New upstream release
    - Fixed FTBFS with gcc-4.5 (Closes: #565072)

  [ Ying-Chun Liu (PaulLiu) ]
  * Remove debian/patches/002_fix_missing_include.patch: upstream included
  * Update debain/copyright to dep-5 rev 173

  [ Elliot Glaysher <glaysher@umich.edu> ]
  * Fix graphical defects in Clannad
  * Implement voice replay buttons in scrollback
  * Implement the "Return to Previous Selection" feature
  * Several efficiency fixes.
  * Fix the location of the name window in most games.
  * Fix graphical defects in Clannad

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 16 Mar 2011 16:06:56 +0800

=== debian/control ===
Source: rlvm
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
               google-mock,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-serialization-dev,
               libboost-signals-dev,
               libboost-thread-dev,
               libfreetype6-dev,
               libgl1-mesa-dev,
               libglew1.5-dev,
               libgtest-dev,
               libgtk2.0-dev,
               libguichan-dev,
               libjpeg-dev,
               liblua5.1-0-dev,
               libluabind-dev,
               libmad0-dev,
               libogg-dev,
               libpng-dev,
               libsdl-image1.2-dev,
               libsdl-mixer1.2-dev,
               libsdl-ttf2.0-dev,
               libsdl1.2-dev,
               libvorbis-dev,
               pkg-config,
               scons,
               zlib1g-dev
Standards-Version: 3.9.3
Homepage: http://www.elliotglaysher.org/rlvm/

Package: rlvm
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: RealLive virtual machine clone
 rlvm is a Free Software reimplementation of VisualArt's KK's RealLive
 interpreter. RealLive is a game engine used to write visual novels, used in
 the games Kanon, Air, CLANNAD, Planetarian, Tomoyo After and Little Busters,
 among many others.

## rlvm 0.13

=== SConstruct ===
--- 
+++ 
@@ -12,6 +12,8 @@
 AddOption('--coverage', action='store_true',
           help='Builds the unit tests for running through gcov, runs them, '
           'runs gcov, and then generates an html report with lcov.')
+AddOption('--pprof', action='store_true',
+          help='Build with Google\'s performance tools.')
 AddOption('--fullstatic', action='store_true',
           help='Builds a static binary, linking in all libraries.')
 
@@ -20,13 +22,13 @@
   tools = ["default", "rlvm"],
 
   LIBS = [
-    "boost_program_options-mt",
-    "boost_serialization-mt",
-    "boost_iostreams-mt",
-    "boost_filesystem-mt",
-    "boost_date_time-mt",
-    "boost_thread-mt",
-    "boost_system-mt",
+    "boost_program_options",
+    "boost_serialization",
+    "boost_iostreams",
+    "boost_filesystem",
+    "boost_date_time",
+    "boost_thread",
+    "boost_system",
     "z"
   ],
 
@@ -44,10 +46,6 @@
 
   CPPDEFINES = [
     "HAVE_CONFIG_H",
-
-    # boost made a large non-backwards compatible change to their filesystem
-    # library. Specify version 2 explicitly.
-    ["BOOST_FILESYSTEM_VERSION", 2],
 
     # We use gettext for translations.
     "ENABLE_NLS",
@@ -328,6 +326,19 @@
 
     LIBS = [ "gcov" ]
   )
+elif GetOption('pprof'):
+  env["BUILD_DIR"] = "#/build/pprof"
+  env['BUILD_TYPE'] = "Release"
+
+  env.Append(
+    CPPFLAGS = [
+      "-O0",
+      "-g",
+    ],
+
+    LIBS = [ "tcmalloc",
+             "profiler"]
+  )
 else:
   # Add debugging flags to all binaries here
   env.Append(

=== debian/changelog ===
rlvm (0.13-1build1) trusty; urgency=medium

  * No change rebuild against glew 1.10.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 02 Jan 2014 13:10:36 +0000

rlvm (0.13-1) unstable; urgency=low

  * New upstream release
    - rlvm will now warn on startup when it detects Japanese save data, but
      English patched game files, and offer to reset the save data.
    - Much better support for Little Busters. Most graphical glitches during
      the Little Busters Refrain have been fixed.
    - TCC tone curve effects have been reverse-engineered and implemented
      (thanks to lurkmoar)
    - Sepia scenes (and other graphical filters) should look much better.
    - Simple shake commands implemented (fancy per-layer shaking still
      unimplemented).
    - Make animations smooth: data should be uploaded to the graphics card
      before an animation loop starts, not while the animation loop is
      running.
    - Fixes finding system fonts on Linux
    - Thanks to Elliot Glaysher <glaysher@umich.edu>
  * Remove upstreamed patches:
    - debian/patches/002_675426ad62bccf1de10b0ae31dd46331ec47aacb.patch
    - debian/patches/003_5dafabf5448635c4d4526d6e35ea7ec664a27261.patch
    - debian/patches/004_boost-drop-mt.patch
    - debian/patches/005_missing-include.patch

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sat, 02 Nov 2013 02:57:13 +0800

rlvm (0.12-5) unstable; urgency=low

  [ Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com> ]
  * Drop obsolete -mt suffixes from boost libraries.
  * Add missing include in TextPage.hpp

  [ Colin Watson <cjwatson@ubuntu.com> ]
  * Rebuild for libglew1.8.
  
  [ Ying-Chun Liu (PaulLiu) <paulliu@debian.org> ]
  * Merge Ubuntu's changes.
    - Import 2 patches from the upstream git tree.
      - 002_675426ad62bccf1de10b0ae31dd46331ec47aacb.patch
      - 003_5dafabf5448635c4d4526d6e35ea7ec664a27261.patch
  * Fix the FTBFS (Closes: #725558)
  * Bump Standards-Version to 3.9.4: nothing needs to be changed
  * Bump debhelper compat version from 7 to 9.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 10 Oct 2013 03:09:54 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
-Build-Depends: debhelper (>= 7.0.50~),
+Build-Depends: debhelper (>= 9),
                google-mock,
                libboost-date-time-dev,
                libboost-dev,
@@ -34,7 +34,7 @@
                pkg-config,
                scons,
                zlib1g-dev
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://www.elliotglaysher.org/rlvm/
 
 Package: rlvm

## rlvm 0.13.1

=== SConstruct ===
--- 
+++ 
@@ -113,11 +113,19 @@
       CPPPATH = ["/opt/local/include/"],
       LIBPATH = ["/opt/local/lib/"]
     )
+  # Manually installed / homebrew
   if os.path.exists("/usr/local/"):
     env['ENV']['PATH'] += ":/usr/local/bin/"
     env.Append(
       CPPPATH = ["/usr/local/include/"],
       LIBPATH = ["/usr/local/lib/"]
+    )
+  if os.path.exists('/usr/local/opt/gettext/'):
+    # Homebrew does this bogus thing where installing the gettext bottle doesn't
+    # actually symlink the headers and libraries into /usr/local/.
+    env.Append(
+      CPPPATH = ["/usr/local/opt/gettext/include/"],
+      LIBPATH = ["/usr/local/opt/gettext/lib/"]
     )
 
 #########################################################################
@@ -388,11 +396,3 @@
 if GetOption("coverage"):
   env.SConscript("SConscript.coverage",
                  variant_dir="$BUILD_DIR/",
-                 duplicate=0,
-                 exports='env')
-
-# In addition to all that, we also want to build the translation files.
-env.Command("build/locale/ja/LC_MESSAGES/rlvm.mo",
-            "po/ja.po",
-            ["mkdir -p build/locale/ja/LC_MESSAGES/",
-             "msgfmt -o build/locale/ja/LC_MESSAGES/rlvm.mo po/ja.po"])

=== debian/changelog ===
rlvm (0.13.1-1) unstable; urgency=low

  [ Elliot Glaysher <glaysher@umich.edu> ]
  * New upstream release
    - Fix crash on the Clannad loading screen on certain OpenGL drivers.
    - Fix order of font loading to prefer working fonts on Linux.

  [ Ying-Chun Liu (PaulLiu) <paulliu@debian.org> ]
  * Bump Standards-Version to 3.9.5: nothing needs to be changed
  * Update rlvm.6 from /debian.upstream

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sat, 22 Mar 2014 20:55:36 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: rlvm
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
+Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
 Build-Depends: debhelper (>= 9),
                google-mock,
                libboost-date-time-dev,
@@ -34,12 +33,13 @@
                pkg-config,
                scons,
                zlib1g-dev
-Standards-Version: 3.9.4
-Homepage: http://www.elliotglaysher.org/rlvm/
+Standards-Version: 3.9.5
+Homepage: http://www.elliotglaysher.org/rlvm
 
 Package: rlvm
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ttf-japanese-gothic, ${misc:Depends}, ${shlibs:Depends}
+Suggests: ttf-dejavu-core
 Description: RealLive virtual machine clone
  rlvm is a Free Software reimplementation of VisualArt's KK's RealLive
  interpreter. RealLive is a game engine used to write visual novels, used in

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	scons -e --release build/rlvm build/locale

override_dh_auto_clean:
	dh_auto_clean
	rm -Rf build/ .sconf_temp/

## rlvm 0.14

=== SConstruct ===
--- 
+++ 
@@ -21,16 +21,7 @@
 env = Environment(
   tools = ["default", "rlvm"],
 
-  LIBS = [
-    "boost_program_options",
-    "boost_serialization",
-    "boost_iostreams",
-    "boost_filesystem",
-    "boost_date_time",
-    "boost_thread",
-    "boost_system",
-    "z"
-  ],
+  LIBS = ["z"],
 
   LOCAL_LIBS = [],
 
@@ -71,6 +62,27 @@
   # Whether we build the test binary that requires lua.
   BUILD_LUA_TESTS = False,
 )
+
+if env['PLATFORM'] == "darwin":
+  env.Append(
+    LIBS = [
+      "boost_program_options-mt",
+      "boost_serialization-mt",
+      "boost_iostreams-mt",
+      "boost_filesystem-mt",
+      "boost_date_time-mt",
+      "boost_thread-mt",
+      "boost_system-mt"])
+else:
+  env.Append(
+    LIBS = [
+      "boost_program_options",
+      "boost_serialization",
+      "boost_iostreams",
+      "boost_filesystem",
+      "boost_date_time",
+      "boost_thread",
+      "boost_system"])
 
 if GetOption("fullstatic"):
   env["FULL_STATIC_BUILD"] = True
@@ -385,14 +397,3 @@
 # Build the rlvmTests binary that uses those SEEN.TXT files.
 env.SConscript("SConscript.test",
                variant_dir="$BUILD_DIR/",
-               duplicate=0,
-               exports='env')
-
-env.SConscript("SConscript.luarlvm",
-               variant_dir="$BUILD_DIR/",
-               duplicate=0,
-               exports='env')
-
-if GetOption("coverage"):
-  env.SConscript("SConscript.coverage",
-                 variant_dir="$BUILD_DIR/",

=== debian/changelog ===
rlvm (0.14-5.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs on boost1.83. (Closes: #1056017)
  * Use libboost-timer-dev instead of libboost-date-time-dev.

 -- Bo YU <tsu.yubo@gmail.com>  Mon, 25 Dec 2023 20:40:29 +0800

rlvm (0.14-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Replace libglew1.5-dev with libglew-dev

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 03 Oct 2021 21:16:33 +0200

rlvm (0.14-5) unstable; urgency=low

  [ Giovanni Mascellani <gio@debian.org> ]
  * Remove dependency on package libboost-signals-dev, which does not exist
    any more.
  * Fix compilation adding a missing header.

  [ Ying-Chun Liu (PaulLiu) <paulliu@debian.org> ]
  * Merge Giovanni's patch for fixing FTBFS with Boost 1.71 (Closes: #954649)
    - Thanks to Giovanni Mascellani

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 09 Jun 2020 01:18:33 +0800

rlvm (0.14-4) unstable; urgency=low

  * Add 004_port_to_python3.patch: porting to python3 (Closes: #947579)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sun, 02 Feb 2020 00:59:32 +0800

rlvm (0.14-3) unstable; urgency=low

  * Use pkg-config instead of freetype-config (Closes: #892454)
    - Add 003_use_pkg-config_for_freetype2.patch
    - Use local debian/freetype-config which will call pkg-config instead
  - Bump Standards-Version to 4.2.1: nothing needs to be changed.
  - Bump debhelper compat to 10
  - Fix lintian warnings on debian/copyright

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 24 Oct 2018 05:21:20 +0800

rlvm (0.14-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  [ Logan Rosen ]
  * debian/patches/include-iostream.patch: Grab patch from upstream to include
    iostream header and fix FTBFS (Closes: #831207).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Aug 2016 18:24:56 +0200

rlvm (0.14-2) unstable; urgency=low

  * Fix old ttf-japanese-gothic dependencies. (Closes: #805343)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 18 Nov 2015 14:45:07 +0800

rlvm (0.14-1) unstable; urgency=low

  * New upstream release
  * Bump Standards-Version to 3.9.6: nothing needs to be changed

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 22 Oct 2014 03:24:19 +0800

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,19 @@
 Section: games
 Priority: optional
 Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                google-mock,
-               libboost-date-time-dev,
                libboost-dev,
                libboost-filesystem-dev,
                libboost-iostreams-dev,
                libboost-program-options-dev,
                libboost-python-dev,
                libboost-serialization-dev,
-               libboost-signals-dev,
                libboost-thread-dev,
+               libboost-timer-dev,
                libfreetype6-dev,
                libgl1-mesa-dev,
-               libglew1.5-dev,
+               libglew-dev,
                libgtest-dev,
                libgtk2.0-dev,
                libguichan-dev,
@@ -33,12 +32,14 @@
                pkg-config,
                scons,
                zlib1g-dev
-Standards-Version: 3.9.5
-Homepage: http://www.elliotglaysher.org/rlvm
+Standards-Version: 4.2.1
+Homepage: http://rlvm.net
 
 Package: rlvm
 Architecture: any
-Depends: ttf-japanese-gothic, ${misc:Depends}, ${shlibs:Depends}
+Depends: fonts-vlgothic | fonts-japanese-gothic,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Suggests: ttf-dejavu-core
 Description: RealLive virtual machine clone
  rlvm is a Free Software reimplementation of VisualArt's KK's RealLive

=== debian/watch ===
version=3
http://eglaysher.github.com/rlvm/ \
 http://github.com/eglaysher/rlvm/tarball/release-([.\d]*)
